<template>
  <div>
    [[ Template current content type ]]
    {{ node }}
    <component v-if="$options.components[contentType]" :is="contentType" :path="path" :is-new="true" :key="componentKey"></component>
  </div>
</template>

<script>
import Vue from 'vue'
import _ from 'lodash'

import Page from '@/components/Page'
import Test from '@/components/Test'

import { EDITABLE_GHOST_ZONES, EDITABLE_NODE_PRESETS } from '@/components/Editable/config'

import { mapActions, mapGetters } from 'vuex'

// import NodeByPath from '@/mixins/NodeByPath'

export default {
  mixins: [Vue.i3Mixins.NodeByPath],

  components: {
    'page': Page,
    'test': Test
  },

  props: {
    path: {
      type: String,
      required: true
    },
    contentType: {
      type: String,
      required: true
    },
    preset: {
      type: String,
      required: false
    },
    keepSidebar: {
      type: Boolean,
      required: false
    }
  },

  data () {
    return {
      // nid: 'new-' + this.newNodeId
    }
  },

  watch: {
    node () {
      console.log('kkokokokokokok')
      console.log(this.node)
      this.setNodeItem({ data: { path: this.path, node: this.node } }).then(() => {
        this.getCurrentNode()
      })
    },

    keepSidebar () {
      this.handleSidebarPage()
    }
  },

  computed: {
    ...mapGetters({
      // getFieldConfig: 'Y3TI/getFieldConfig',
      getEditedNodes: 'Y3TI/getEditedNodes',
      // backPageTitle: 'Y3TI/backPageTitle'
      contentTypes: 'Y3TI/contentTypes',
      newNodeId: 'Y3TI/newNodeId',
      routing: 'Y3TI/routing',
      currentSidebarPage: 'Y3TI/currentSidebarPage'
    }),

    nid () {
      return 'new-' + this.newNodeId
    },

    componentKey () {
      return [this.nid, this.contentType, this.preset].join('-')
    },

    presetData () {
      if (this.preset) {
        return _.get(EDITABLE_NODE_PRESETS, [this.contentType, this.preset, 'data'], {})
      }
      return {}
    },

    node () {
      return {
        _new: true,
        _type: this.contentType,
        nid: this.nid,
        ...this.presetData
      }
    },

    currentNode () {
      return this.getEditedNodes([this.contentType, 'nid-' + this.nid])
    }
  },

  methods: {
    ...mapActions({
      pushSidebarPage: 'Y3TI/pushSidebarPage',
      // backSidebarPage: 'Y3TI/backSidebarPage',
      setNodeItem: 'Y3TI/setNodeItem',
      // setEditableNodeCall: 'Y3TI/setEditableNode',
      setEditableActiveZone: 'Y3TI/setEditableActiveZone',
      getContentTypes: 'Y3TI/getContentTypes'
    }),

    pushPage (component, props, title) {
      return this.pushSidebarPage({ data: { page: { component, props, title } } })
    },
    // async setEditableNode (node, related) {
    //   await this.setEditableNodeCall({ data: { path: this.path, node, related } }).catch((err) => {
    //     console.log(err)
    //   })
    // },
    // pushPage (component, props, title) {
    //   return this.pushSidebarPage({ data: { page: { component, props, title } } })
    // },

    // backPage () {
    //   return this.backSidebarPage()
    // },

    // addNode (node) {
    //   console.log('node', node)
    // },

    handleGhostZone (ghostZone) {
      if (!ghostZone) {
        const ghostZones = EDITABLE_GHOST_ZONES(this.currentNode)
        if (ghostZones) {
          ghostZone = ghostZones[this.contentType]
        }
      }

      if (ghostZone) {
        this.setEditableActiveZone({ data: { isDefault: true, ...ghostZone } })
      }
    },

    handleSidebarPage () {
      this.getContentTypes({ options: { lazy: true } }).then(() => {
        if (!this.keepSidebar && _.isEmpty(this.currentSidebarPage)) {
          this.pushPage('new-node-form-category', {}, 'New ' + this.contentTypes[this.contentType])
        }
      })
    }
    // nextComponent (key) {
    //   return _.isEmpty(EDITABLE_NODE_PRESETS[key]) ? 'new-node-form-category' : 'new-node-presets-category'
    // }
  },

  created () {
    this.setNodeItem({ data: { path: this.path, node: this.node } }).then(() => {
      this.getCurrentNode()
    })
    this.handleSidebarPage()
    // this.setEditableNode(this.node)
    // this.handleGhostZone()
    // this.$router.push({ name: 'NewNode' })
  }
}
</script>

<style lang="scss" scoped>
</style>
